package snake;

import java.awt.Graphics;
import java.awt.Menu;
import java.awt.MenuBar;
import java.awt.MenuItem;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

import javax.swing.JFrame;

public class Frame extends JFrame implements KeyListener {

	Boolean isAlive;
	Boolean isPause;
	Panel panel;
	Character direction;
	private static final long serialVersionUID = 1L;

	public Frame() {

		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setSize(300, 300);
		addKeyListener(this);
		panel = new Panel();
		add(panel);
		setVisible(true);
		isAlive = true;
		isPause = false;
		direction = new Character('d');
		MenuBar menuBar = new MenuBar();
		Menu menu = new Menu("menu");
		MenuItem reset = new MenuItem("newgame");
		MenuItem pause = new MenuItem("pause");

		pause.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {

				if (!isPause)
					isPause = true;
				else
					isPause = false;
			}

		});

		reset.addActionListener(new ActionListener() {

			@Override
			public void actionPerformed(ActionEvent e) {

				reset();
			}

		});

		menu.add(reset);
		menu.add(pause);
		menuBar.add(menu);
		setMenuBar(menuBar);

	}

	public void reset() {
		panel.reset();
		isAlive = true;
	}

	@Override
	public void keyTyped(KeyEvent e) {

	}

	@Override
	public void keyPressed(KeyEvent e) {

		if (e.getKeyCode() == KeyEvent.VK_UP)
			direction = 'w';
		if (e.getKeyCode() == KeyEvent.VK_DOWN)
			direction = 's';
		if (e.getKeyCode() == KeyEvent.VK_LEFT)
			direction = 'a';
		if (e.getKeyCode() == KeyEvent.VK_RIGHT)
			direction = 'd';
	}

	@Override
	public void keyReleased(KeyEvent e) {

	}

	public void paint(Graphics g) {
		panel.repaint();
	}

}
